import React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import { ActionSheetItemProps } from './ActionSheetItem';
import type { BaseActionSheetProps } from './interface';
export interface ActionSheetCssVars {
    '--background'?: React.CSSProperties['background'];
    '--border-radius'?: React.CSSProperties['borderRadius'];
    '--spacing-margin'?: React.CSSProperties['margin'];
    '--item-height'?: React.CSSProperties['height'];
    '--item-font-size'?: React.CSSProperties['fontSize'];
    '--item-font-weight'?: React.CSSProperties['fontWeight'];
    '--item-text-color'?: React.CSSProperties['color'];
    '--item-active-background'?: React.CSSProperties['background'];
    '--item-opacity-disabled'?: React.CSSProperties['opacity'];
    '--cancel-text-color'?: React.CSSProperties['color'];
    '--cancel-margin-top'?: React.CSSProperties['marginTop'];
}
export interface ActionSheetProps extends BaseActionSheetProps, HTMLProps<ActionSheetCssVars> {
    safeArea?: boolean;
    actions?: ActionSheetItemProps[];
    onAction?: (action: ActionSheetItemProps, index: number) => void;
}
declare const ActionSheet: React.ForwardRefExoticComponent<ActionSheetProps & React.RefAttributes<HTMLDivElement>>;
export default ActionSheet;
