import * as React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import type { BaseBadgeProps } from './interface';
export interface BadgeCssVars {
    '--dot-size'?: string | number;
    '--color'?: React.CSSProperties['background'];
    '--text-color'?: React.CSSProperties['color'];
    '--border-color'?: React.CSSProperties['borderColor'];
    '--font-size'?: React.CSSProperties['fontSize'];
    '--font-weight'?: React.CSSProperties['fontWeight'];
    '--height'?: React.CSSProperties['height'];
    '--padding-horizontal'?: React.CSSProperties['padding'];
    '--border-radius'?: React.CSSProperties['borderRadius'];
    '--top'?: React.CSSProperties['top'];
    '--right'?: React.CSSProperties['right'];
}
export declare type BadgeProps = BaseBadgeProps & HTMLProps<BadgeCssVars>;
declare const Badge: React.ForwardRefExoticComponent<BaseBadgeProps & HTMLProps<BadgeCssVars> & React.RefAttributes<HTMLSpanElement>>;
export default Badge;
