import React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import { BaseCalendarProps } from './interface';
export interface CalendarCssVars {
    '--background'?: React.CSSProperties['background'];
    '--padding-horizontal'?: React.CSSProperties['paddingLeft'];
    '--padding-vertical'?: React.CSSProperties['paddingTop'];
    '--header-height'?: React.CSSProperties['height'];
    '--week-height'?: React.CSSProperties['height'];
    '--week-font-size'?: React.CSSProperties['fontSize'];
    '--week-font-weight'?: React.CSSProperties['fontWeight'];
    '--week-background'?: React.CSSProperties['background'];
    '--week-text-color'?: React.CSSProperties['color'];
    '--month-font-size'?: React.CSSProperties['fontSize'];
    '--month-font-weight'?: React.CSSProperties['fontWeight'];
    '--month-height'?: React.CSSProperties['height'];
    '--month-scroll-background'?: React.CSSProperties['background'];
    '--day-height'?: React.CSSProperties['height'];
    '--day-width'?: React.CSSProperties['width'];
    '--day-margin-vertical'?: React.CSSProperties['marginTop'];
    '--day-font-size'?: React.CSSProperties['fontSize'];
    '--day-text-color'?: React.CSSProperties['color'];
    '--day-today-background'?: React.CSSProperties['background'];
    '--day-today-text-color'?: React.CSSProperties['color'];
    '--day-selected-border-radius'?: React.CSSProperties['borderRadius'];
    '--day-selected-background'?: React.CSSProperties['background'];
    '--day-selected-text-color'?: React.CSSProperties['color'];
    '--day-selected-shadow'?: React.CSSProperties['background'];
    '--day-range-background'?: React.CSSProperties['background'];
    '--day-range-text-color'?: React.CSSProperties['color'];
    '--action-btn-disabled'?: React.CSSProperties['color'];
}
export declare type CalendarProps = BaseCalendarProps & HTMLProps<CalendarCssVars>;
declare const Calendar: React.ForwardRefExoticComponent<BaseCalendarProps & HTMLProps<CalendarCssVars> & React.RefAttributes<HTMLDivElement>>;
export default Calendar;
