import { ReactNode } from 'react';
import { FieldNames as WheelFieldNames, WheelValue } from '../wheel/interface';
export declare type CascaderValue = number | string;
export interface CascaderOption {
    [key: string]: any;
    label: ReactNode;
    value: WheelValue;
    children: CascaderOption[];
}
declare type FieldNames = Partial<WheelFieldNames> & {
    children?: string;
};
export declare type CascaderItem = Pick<CascaderOption, 'label' | 'value'>;
declare type TItemRender = (data: CascaderItem) => ReactNode;
export interface BaseCascaderViewProps {
    defaultValue?: CascaderValue[];
    value?: CascaderValue[];
    dataSource: CascaderOption[];
    fieldNames?: FieldNames;
    cols?: number;
    itemRender?: TItemRender;
    onChange?: (value: CascaderValue[], items: CascaderItem[]) => void;
}
export {};
