import React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import CollapseItem from './CollapseItem';
import type { BaseCollapseProps } from './interface';
export interface CollapseCssVars {
    '--border-color'?: React.CSSProperties['color'];
    '--arrow-color'?: React.CSSProperties['color'];
    '--arrow-size'?: React.CSSProperties['width'];
    '--arrow-width'?: React.CSSProperties['width'];
    '--arrow-disabled-color'?: React.CSSProperties['color'];
    '--header-height'?: React.CSSProperties['height'];
    '--header-padding-horizontal'?: React.CSSProperties['left'];
    '--header-padding-vertical'?: React.CSSProperties['top'];
    '--header-disable-color'?: React.CSSProperties['color'];
    '--content-color'?: React.CSSProperties['color'];
    '--content-padding-vertical'?: React.CSSProperties['top'];
    '--content-padding-horizontal'?: React.CSSProperties['left'];
}
export declare type CollapseProps = BaseCollapseProps & React.PropsWithChildren<HTMLProps<CollapseCssVars>>;
interface CompoundedComponent extends React.ForwardRefExoticComponent<CollapseProps & React.RefAttributes<HTMLElement>> {
    Item: typeof CollapseItem;
}
declare const Collapse: CompoundedComponent;
export default Collapse;
