import * as React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import type { BaseCustomInputProps } from './interface';
export interface CustomInputCssVars {
    '--height'?: React.CSSProperties['height'];
    '--line-height'?: React.CSSProperties['lineHeight'];
    '--font-size'?: React.CSSProperties['fontSize'];
    '--color'?: React.CSSProperties['color'];
    '--background'?: React.CSSProperties['background'];
    '--label-font-size'?: React.CSSProperties['fontSize'];
    '--placeholder-color'?: React.CSSProperties['color'];
    '--disabled-color'?: React.CSSProperties['color'];
    '--clear-icon-size'?: React.CSSProperties['width'];
    '--clear-icon-color'?: React.CSSProperties['color'];
    '--cursor-height'?: React.CSSProperties['height'];
    '--cursor-width'?: React.CSSProperties['width'];
    '--cursor-color'?: React.CSSProperties['color'];
}
export declare type CustomInputProps = BaseCustomInputProps & HTMLProps<CustomInputCssVars> & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'type' | 'onChange' | 'onFocus' | 'onBlur'>;
export interface CustomInputRef {
    focus: () => void;
    blur: () => void;
}
declare const CustomInput: React.ForwardRefExoticComponent<BaseCustomInputProps & HTMLProps<CustomInputCssVars> & Omit<React.InputHTMLAttributes<HTMLInputElement>, "type" | "onChange" | "onFocus" | "onBlur"> & React.RefAttributes<CustomInputRef>>;
export default CustomInput;
