import { render } from '@testing-library/react';
import React from 'react';
import DatePickerView from '../index';
describe('DatePickerView', function () {
  afterEach(function () {
    jest.restoreAllMocks();
  });
  it('snapshot', function () {
    var wrapper = render( /*#__PURE__*/React.createElement(DatePickerView, {
      defaultValue: new Date('2017/12/3 14:00')
    }));
    expect(wrapper.asFragment()).toMatchSnapshot();
  });
  it('meridiem hour snapshot', function () {
    var wrapper = render( /*#__PURE__*/React.createElement(DatePickerView, {
      defaultValue: new Date('2017/12/3 14:00'),
      columnType: ['meridiem', 'hour', 'minute']
    }));
    expect(wrapper.asFragment()).toMatchSnapshot();
  });
  it('week snapshot', function () {
    var wrapper = render( /*#__PURE__*/React.createElement(DatePickerView, {
      defaultValue: new Date('2017/12/3 14:00'),
      columnType: ['year', 'week', 'week-day']
    }));
    expect(wrapper.asFragment()).toMatchSnapshot();
  });
});