import getFileDetail from '../../utils/getFileDetail';
describe('getFileDetail', function () {
  it('should get image file detail', function () {
    var file = new File(['foo'], 'foo.png', {
      type: 'image/png'
    });
    var actual = getFileDetail(file);
    expect(actual).toEqual({
      fileName: 'foo.png',
      fileSize: 3,
      fileType: 'image/png',
      isPic: true
    });
  });
  it('should get image file type if file has no type property', function () {
    var file = new File(['foo'], 'foo.png');
    var actual = getFileDetail(file);
    expect(actual).toEqual({
      fileName: 'foo.png',
      fileSize: 3,
      fileType: 'png',
      isPic: false
    });
  });
  it('should get text file detail', function () {
    var file = new File(['foo'], 'foo.txt', {
      type: 'text/plain'
    });
    var actual = getFileDetail(file);
    expect(actual).toEqual({
      fileName: 'foo.txt',
      fileSize: 3,
      fileType: 'text/plain',
      isPic: false
    });
  });
});