import changeImageSize from './changeImageSize';

/**
 * generate preview image
 * modify image quality
 *
 * @param file
 * @param quality
 * @param fileType
 * @param maxWidth
 * @param maxHeight
 * @param callback
 */
export default function createThumbnail(_ref) {
  var file = _ref.file,
      quality = _ref.quality,
      fileType = _ref.fileType,
      maxWidth = _ref.maxWidth,
      maxHeight = _ref.maxHeight;
  return new Promise(function (resolve) {
    var img = document.createElement('img');
    window.URL = window.URL || window.webkitURL;

    img.onload = function () {
      var imgUrl;

      if (quality || maxWidth || maxHeight) {
        imgUrl = changeImageSize(img, quality, fileType);
      } else {
        imgUrl = img.src;
      }

      resolve(imgUrl || '');
    };

    img.src = window.URL.createObjectURL(file);
  });
} // FileReader
// export default function createThumbnail({ file, quality, fileType, maxWidth, maxHeight }, callback) {
//   const img = document.createElement('img');
//   const reader = new FileReader();
//   reader.onload = (e) => {
//     img.src = e.target.result;
//     callback(img.src);
//   };
//   reader.readAsDataURL(file);
// }