import React, { CSSProperties } from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import type { BaseKeyBoardProps } from './interface';
export interface KeyboardCssVars {
    '--background'?: CSSProperties['background'];
    '--item-background'?: CSSProperties['background'];
    '--item-active-background'?: CSSProperties['background'];
    '--item-gap'?: CSSProperties['gap'];
    '--item-height'?: CSSProperties['height'];
    '--item-font-size'?: CSSProperties['fontSize'];
    '--item-border-radius'?: CSSProperties['borderRadius'];
    '--item-box-shadow'?: CSSProperties['boxShadow'];
    '--ok-background'?: CSSProperties['background'];
    '--ok-font-size'?: CSSProperties['fontSize'];
    '--ok-text-color'?: CSSProperties['color'];
}
export declare type KeyboardProps = BaseKeyBoardProps & HTMLProps<KeyboardCssVars>;
declare const Keyboard: React.ForwardRefExoticComponent<BaseKeyBoardProps & HTMLProps<KeyboardCssVars> & React.RefAttributes<HTMLDivElement>>;
export default Keyboard;
