import * as React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import type { BaseListProps } from './interface';
export interface ListCssVars {
    '--item-height'?: React.CSSProperties['height'];
    '--item-padding-horizontal'?: React.CSSProperties['paddingLeft'];
    '--item-padding-vertical'?: React.CSSProperties['paddingTop'];
    '--item-background'?: React.CSSProperties['background'];
    '--item-active-background'?: React.CSSProperties['background'];
    '--item-separator-color'?: React.CSSProperties['color'];
    '--item-title-font-size'?: React.CSSProperties['fontSize'];
    '--item-title-white-space'?: React.CSSProperties['whiteSpace'];
    '--item-title-line-height'?: React.CSSProperties['lineHeight'];
    '--item-suffix-text-color'?: React.CSSProperties['color'];
    '--item-space'?: string | number;
    '--item-arrow-width'?: React.CSSProperties['borderWidth'];
    '--item-arrow-color'?: React.CSSProperties['color'];
    '--item-arrow-size'?: string | number;
    '--item-description-font-size'?: React.CSSProperties['fontSize'];
    '--item-description-text-color'?: React.CSSProperties['color'];
    '--item-description-line-height'?: React.CSSProperties['lineHeight'];
    '--item-inline-title-width'?: React.CSSProperties['width'];
}
export declare type ListProps = React.PropsWithChildren<BaseListProps & HTMLProps<ListCssVars>>;
declare const List: React.ForwardRefExoticComponent<BaseListProps & HTMLProps<ListCssVars> & {
    children?: React.ReactNode;
} & React.RefAttributes<HTMLUListElement>>;
export default List;
