import * as React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import type { BaseLoadingProps } from './interface';
export interface LoadingCssVars {
    '--size'?: React.CSSProperties['width' | 'height'];
    '--size-large'?: React.CSSProperties['width' | 'height'];
    '--stroke-color'?: React.CSSProperties['stroke'];
    '--stroke-active-color'?: React.CSSProperties['stroke'];
    '--spinner-item-color'?: React.CSSProperties['color'];
    '--spinner-item-width'?: React.CSSProperties['width'];
    '--spinner-item-height'?: React.CSSProperties['height'];
    '--spinner-item-border-radius'?: React.CSSProperties['borderRadius'];
}
export declare type LoadingProps = BaseLoadingProps & HTMLProps<LoadingCssVars> & {
    onClick?: React.MouseEventHandler<HTMLDivElement>;
};
declare const Loading: React.ForwardRefExoticComponent<BaseLoadingProps & HTMLProps<LoadingCssVars> & {
    onClick?: React.MouseEventHandler<HTMLDivElement>;
} & React.RefAttributes<HTMLDivElement>>;
export default Loading;
