import type { Locale } from '../config-provider/interface';
export declare enum REFRESH_STATE {
    normal = 0,
    pull = 1,
    drop = 2,
    loading = 3,
    success = 4,
    failure = 5
}
export declare enum LOAD_STATE {
    normal = 0,
    abort = 1,
    loading = 2,
    success = 3,
    failure = 4,
    complete = 5
}
export interface PullAction {
    state?: REFRESH_STATE | LOAD_STATE;
    startDistance?: number;
    distance?: number;
    render?: (state?: REFRESH_STATE | LOAD_STATE, percent?: number) => any;
    handler?: () => void;
}
export interface BasePullProps {
    refresh?: PullAction;
    load?: PullAction;
    animationDuration?: number;
    stayTime?: number;
    locale?: Locale['Pull'];
}
