import React from 'react';
import type { BaseStepperProps } from './interface';
import type { HTMLProps } from '../utils/utilityTypes';
export interface StepperCssVars {
    '--height'?: React.CSSProperties['height'];
    '--input-width'?: React.CSSProperties['width'];
    '--input-background'?: React.CSSProperties['background'];
    '--input-border-width'?: React.CSSProperties['borderWidth'];
    '--input-border-color'?: React.CSSProperties['borderColor'];
    '--input-border-radius'?: React.CSSProperties['borderRadius'];
    '--input-text-color'?: React.CSSProperties['color'];
    '--input-font-size'?: React.CSSProperties['fontSize'];
    '--input-disabled-text-color'?: React.CSSProperties['color'];
    '--input-disabled-opacity'?: React.CSSProperties['opacity'];
    '--input-margin'?: React.CSSProperties['margin'];
    '--input-padding'?: React.CSSProperties['padding'];
    '--icon-font-size'?: React.CSSProperties['fontSize'];
}
export declare type StepperProps = BaseStepperProps & HTMLProps<StepperCssVars>;
declare const Stepper: React.ForwardRefExoticComponent<BaseStepperProps & HTMLProps<StepperCssVars> & React.RefAttributes<unknown>>;
export default Stepper;
