import * as React from 'react';
import type { BaseSwitchProps } from './interface';
export interface SwitchCssVars {
    '--width'?: React.CSSProperties['width'];
    '--height'?: React.CSSProperties['height'];
    '--background'?: React.CSSProperties['background'];
    '--border-radius'?: React.CSSProperties['borderRadius'];
    '--transition'?: React.CSSProperties['transition'];
    '--checked-background'?: React.CSSProperties['background'];
    '--knob-background'?: React.CSSProperties['background'];
    '--knob-size'?: React.CSSProperties['width' | 'height'];
    '--knob-box-shadow'?: React.CSSProperties['boxShadow'];
    '--knob-border-color'?: React.CSSProperties['borderColor'];
    '--knob-border-width'?: React.CSSProperties['width'];
    '--knob-transition'?: React.CSSProperties['transition'];
}
export declare type SwitchProps = BaseSwitchProps & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'onChange'>;
declare const Switch: React.ForwardRefExoticComponent<BaseSwitchProps & Omit<React.InputHTMLAttributes<HTMLInputElement>, "onChange"> & React.RefAttributes<HTMLDivElement>>;
export default Switch;
