import React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import type { BaseTabBarProps } from './interface';
import TabBarItem from './TabBarItem';
export interface TabBarCssVars {
    '--height'?: React.CSSProperties['height'];
    '--font-size'?: React.CSSProperties['fontSize'];
    '--background'?: React.CSSProperties['background'];
    '--color'?: React.CSSProperties['color'];
    '--active-color'?: React.CSSProperties['color'];
}
export declare type TabBarProps = BaseTabBarProps & React.PropsWithChildren<HTMLProps<TabBarCssVars>>;
interface CompoundedComponent extends React.ForwardRefExoticComponent<TabBarProps & React.RefAttributes<HTMLDivElement>> {
    Item: typeof TabBarItem;
}
declare const TabBar: CompoundedComponent;
export default TabBar;
