import * as React from 'react';
import TabPanel from './TabPanel';
import type { BaseTabsProps } from './interface';
import type { HTMLProps } from '../utils/utilityTypes';
export interface TabsCssVars {
    '--font-size'?: React.CSSProperties['fontSize'];
    '--color'?: React.CSSProperties['color'];
    '--color-disabled'?: React.CSSProperties['color'];
    '--height'?: React.CSSProperties['height'];
    '--active-color'?: React.CSSProperties['color'];
    '--active-line-height'?: React.CSSProperties['height'];
    '--padding-horizontal'?: React.CSSProperties['left'];
    '--padding-vertical'?: React.CSSProperties['top'];
}
export declare type TabsProps = BaseTabsProps & HTMLProps<TabsCssVars>;
interface CompoundedComponent extends React.ForwardRefExoticComponent<TabsProps & React.RefAttributes<HTMLDivElement>> {
    Panel: typeof TabPanel;
}
declare const Tabs: CompoundedComponent;
export default Tabs;
