import React from 'react';
import type { PopperPlacement, PopperTrigger } from '../popper/interface';
import type { HTMLProps } from '../utils/utilityTypes';
import type { BaseTooltipProps } from './interface';
export declare type TooltipPlacement = PopperPlacement;
export declare type TooltipTrigger = PopperTrigger;
interface refHander {
    update: () => void;
}
export interface TooltipCssVars {
    '--font-size'?: React.CSSProperties['fontSize'];
    '--color'?: React.CSSProperties['color'];
    '--background'?: React.CSSProperties['background'];
    '--zindex'?: React.CSSProperties['zIndex'];
    '--spacing'?: React.CSSProperties['height'];
    '--padding-horizontal'?: React.CSSProperties['paddingLeft'];
    '--padding-vertical'?: React.CSSProperties['paddingTop'];
    '--arrow-size'?: React.CSSProperties['width'];
    '--arrow-horizontal-offset'?: React.CSSProperties['left'];
    '--arrow-vertical-offset'?: React.CSSProperties['top'];
}
export declare type TooltipProps = BaseTooltipProps & React.PropsWithChildren<HTMLProps<TooltipCssVars>>;
declare const Tooltip: React.ForwardRefExoticComponent<BaseTooltipProps & HTMLProps<TooltipCssVars> & {
    children?: React.ReactNode;
} & React.RefAttributes<refHander>>;
export default Tooltip;
