import * as React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import type { BaseTransitionProps } from './interface';
export interface TransitionChildrenProps extends Required<HTMLProps> {
    visible?: boolean;
}
export interface TransitionProps extends BaseTransitionProps {
    nodeRef?: React.RefObject<HTMLElement> | React.ForwardedRef<HTMLElement>;
    tranisitionName: string;
    duration?: number;
    children: ((props: TransitionChildrenProps, setNodeRef: (node: HTMLElement | null) => void) => React.ReactElement) | React.ReactElement;
    onEnter?: () => void;
    onEnterActive?: () => void;
    onEnterEnd?: () => void;
    onLeave?: () => void;
    onLeaveActive?: () => void;
    onLeaveEnd?: () => void;
}
declare const Transition: React.FC<TransitionProps>;
export default Transition;
