import React from 'react';
import type { BaseCarouselProps } from './interface';
import type { HTMLProps } from '../utils/utilityTypes';
export interface CarouselCssVars {
    '--pagination-margin'?: React.CSSProperties['right' | 'bottom'];
    '--pagination-item-width'?: React.CSSProperties['width'];
    '--pagination-item-height'?: React.CSSProperties['height'];
    '--pagination-item-border-radius'?: React.CSSProperties['borderRadius'];
    '--pagination-item-spacing'?: React.CSSProperties['marginRight'];
    '--pagination-item-background'?: React.CSSProperties['background'];
    '--pagination-item-active-background'?: React.CSSProperties['background'];
}
export declare type CarouselProps = BaseCarouselProps & HTMLProps<CarouselCssVars>;
export interface CarouselHTMLElement extends HTMLDivElement {
    onJumpTo: (index: number) => void;
    onSlideTo: (index: number) => void;
}
declare const Carousel: React.ForwardRefExoticComponent<BaseCarouselProps & HTMLProps<CarouselCssVars> & React.RefAttributes<CarouselHTMLElement>>;
export default Carousel;
