import React from 'react';
import type { BaseMessageProps } from './interface';
import type { HTMLProps } from '../utils/utilityTypes';
export interface MessageCssVars {
    '--line-height'?: React.CSSProperties['lineHeight'];
    '--font-size'?: React.CSSProperties['fontSize'];
    '--icon-size'?: React.CSSProperties['fontSize'];
    '--padding'?: React.CSSProperties['padding'];
}
export declare type MessageProps = BaseMessageProps & React.PropsWithChildren<HTMLProps<MessageCssVars>> & {
    onClick?: React.MouseEventHandler<HTMLDivElement>;
};
declare const Message: React.ForwardRefExoticComponent<BaseMessageProps & HTMLProps<MessageCssVars> & {
    children?: React.ReactNode;
} & {
    onClick?: React.MouseEventHandler<HTMLDivElement>;
} & React.RefAttributes<HTMLDivElement>>;
export default Message;
