import React from 'react';
import type { HTMLAttributes } from 'react';
import type { BaseNavBarProps } from './interface';
import type { HTMLProps } from '../utils/utilityTypes';
export interface NavBarCssVars {
    '--background'?: React.CSSProperties['background'];
    '--height'?: React.CSSProperties['height'];
    '--title-color'?: React.CSSProperties['color'];
    '--title-font-size'?: React.CSSProperties['fontSize'];
    '--title-font-weight'?: React.CSSProperties['fontWeight'];
    '--side-font-size'?: React.CSSProperties['fontSize'];
    '--padding-horizontal'?: React.CSSProperties['paddingLeft'];
}
export declare type NavBarProps = BaseNavBarProps & Omit<HTMLAttributes<HTMLDivElement>, 'title'> & HTMLProps<NavBarCssVars>;
declare const NavBar: React.ForwardRefExoticComponent<BaseNavBarProps & Omit<React.HTMLAttributes<HTMLDivElement>, "title"> & HTMLProps<NavBarCssVars> & React.RefAttributes<HTMLDivElement>>;
export default NavBar;
