import * as React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import type { WheelValue } from '../wheel/interface';
import type { BasePickerViewProps, PickerColumnItem } from './interface';
export interface PickerViewCssVars {
    '--background': React.CSSProperties['background'];
    '--padding': React.CSSProperties['padding'];
    '--mask-start-background': React.CSSProperties['background'];
    '--mask-end-background': React.CSSProperties['background'];
    '--wheel-item-rows': number;
    '--wheel-item-height': React.CSSProperties['height'];
    '--wheel-item-font-size': React.CSSProperties['fontSize'];
    '--wheel-item-text-color': React.CSSProperties['color'];
    '--wheel-item-disabled-text-color': React.CSSProperties['color'];
    '--wheel-item-selected-background': React.CSSProperties['background'];
    '--wheel-item-selected-border-radius': React.CSSProperties['borderRadius'];
}
export declare type PickerViewProps = BasePickerViewProps & HTMLProps<PickerViewCssVars>;
export interface PickerViewInstance {
    value: WheelValue[];
    items: PickerColumnItem[];
    reset: () => void;
}
declare const PickerView: React.ForwardRefExoticComponent<BasePickerViewProps & HTMLProps<PickerViewCssVars> & React.RefAttributes<PickerViewInstance>>;
export default PickerView;
