/// <reference types="react" />
import type { BaseWheelProps, FieldNames as WheelFieldNames, WheelItem, WheelValue } from '../wheel/interface';
export declare type PickerValue = WheelValue;
export declare type PickerColumnItem = WheelItem;
export declare type PickerColumn = PickerColumnItem[];
export interface PickerOption extends PickerColumnItem {
    children?: PickerOption[];
}
export declare type PickerDataSource = (PickerColumn | PickerOption)[];
export interface FieldNames extends WheelFieldNames {
    children: string;
}
export interface BasePickerViewProps extends Pick<BaseWheelProps, 'disabled'> {
    value?: PickerValue | PickerValue[];
    defaultValue?: PickerValue | PickerValue[];
    wheelDefaultValue?: PickerValue | PickerValue[];
    fieldNames?: Partial<FieldNames>;
    dataSource?: PickerDataSource;
    cols?: number;
    itemRender?: (item: PickerColumnItem, index: number) => React.ReactNode;
    onChange?: (value: PickerValue[], items: PickerColumnItem[], index: number) => void;
}
