import type { ReactNode } from 'react';
export declare type KnownSize = 'lg' | 'md' | 'sm';
export declare type ProgressTheme = 'primary' | 'success' | 'warning' | 'danger';
export declare type ProgressSize = KnownSize | number | string;
export declare type ProgressShape = 'line' | 'circle' | 'semi-circle';
export declare type ProgressStrokeShape = 'round' | 'rect';
export declare type ProgressPercent = number;
export declare type PercentFormatter = (percent: number) => ReactNode;
export declare type WeightMap = {
    [weight in KnownSize]: number;
};
export interface BaseProgressProps {
    theme?: ProgressTheme;
    shape?: ProgressShape;
    size?: ProgressSize;
    percent?: ProgressPercent;
    strokeShape?: ProgressStrokeShape;
    strokeWidth?: number;
    text?: PercentFormatter;
}
