import * as React from 'react';
import { HTMLProps } from '../utils/utilityTypes';
import type { WheelItem } from '../wheel/interface';
import type { BaseSelectProps } from './interface';
export interface SelectCssVars {
    '--height': React.CSSProperties['height'];
    '--disabled-color': React.CSSProperties['color'];
    '--placeholder-color': React.CSSProperties['color'];
    '--arrow-color': React.CSSProperties['color'];
    '--arrow-size': React.CSSProperties['width'];
    '--arrow-width': React.CSSProperties['width'];
}
export declare type SelectProps = BaseSelectProps & Omit<React.HTMLAttributes<HTMLDivElement>, 'defaultValue' | 'onChange'> & HTMLProps<SelectCssVars>;
export interface SelectState {
    selectValue: Array<WheelItem>;
    visible: boolean;
}
declare const Select: React.ForwardRefExoticComponent<BaseSelectProps & Omit<React.HTMLAttributes<HTMLDivElement>, "onChange" | "defaultValue"> & HTMLProps<SelectCssVars> & React.RefAttributes<HTMLDivElement>>;
export default Select;
