import * as React from 'react';
import type { HTMLProps } from '../utils/utilityTypes';
import type { SkeletonLineShape, SkeletonShape } from './interface';
export interface SkeletonCssVars {
    '--width'?: React.CSSProperties['width'];
    '--height'?: React.CSSProperties['height'];
    '--border-radius'?: React.CSSProperties['borderRadius'];
    '--margin'?: React.CSSProperties['margin'];
}
export declare type SkeletonProps = HTMLProps<SkeletonCssVars> & {
    shape?: SkeletonShape;
    animated?: boolean;
};
export declare type SkeletonTitleProps = HTMLProps<SkeletonCssVars> & {
    shape?: SkeletonLineShape;
    animated?: boolean;
};
export declare type SkeletonParagraphProps = HTMLProps & {
    shape?: SkeletonLineShape;
    animated?: boolean;
    lineCount?: number;
};
declare const Skeleton: {
    (props: SkeletonProps): JSX.Element;
    displayName: string;
    defaultProps: {
        shape: string;
    };
};
declare const SkeletonTitle: (props: SkeletonTitleProps) => JSX.Element;
declare const SkeletonParagraph: (props: SkeletonParagraphProps) => JSX.Element;
export default Skeleton;
export { SkeletonTitle, SkeletonParagraph };
