import type { MouseEvent, TouchEvent } from 'react';
declare type TouchOrMouseEvent = TouchEvent | MouseEvent;
export interface UseLongPressProps {
    isPreventDefault?: boolean;
    delay?: number;
    onLongPress?: (event: TouchOrMouseEvent) => void;
    onPress?: (event: TouchOrMouseEvent) => void;
    onClear?: (event: TouchOrMouseEvent) => void;
}
declare const useLongPress: ({ isPreventDefault, delay, ...restProps }: UseLongPressProps) => {
    onTouchStart: (event: MouseEvent | TouchEvent) => void;
    onTouchEnd: (event: any) => void;
    onMouseDown: (event: MouseEvent | TouchEvent) => void;
    onMouseUp: (event: any) => void;
    onMouseLeave: (event: any) => void;
};
export default useLongPress;
