import { StringPropertyNames } from '../utilityTypes';
export declare const canUseDOM: boolean;
export declare const getTop: (ele: HTMLElement) => number;
export declare const getLeft: (ele: HTMLElement) => number;
export declare const getBoundingClientRect: (ele: Element) => Omit<DOMRectReadOnly, 'x' | 'y' | 'toJSON'>;
export declare const isNumeric: (n: any) => boolean;
export declare const setStyle: (ele: HTMLElement, styles: {
    [prop: string]: string | number;
}) => void;
declare type Property = StringPropertyNames<CSSStyleDeclaration>;
export declare const getStyleComputedProperty: (ele: Element, property: Property) => string;
export declare const isFixed: (ele: any) => boolean;
export declare const getOuterSizes: (ele: any) => {
    width: any;
    height: any;
};
export declare const getOffsetParent: (ele: any) => any;
declare type ScrollElement = HTMLElement | Window;
export declare const getScrollParent: (element: Element, root?: ScrollElement | undefined) => Window | Element;
export declare const getSupportedPropertyName: (property: any) => any;
export declare const getScrollTop: (element: HTMLElement | Window | Document) => number;
export declare const getScrollLeft: (ele: HTMLElement | Window) => number;
export declare function scrollTo(scrollContainer: HTMLElement | Window, top: number, left: number, duration: number): boolean;
export declare function getElementSize(element: HTMLElement | null): {
    width: number;
    height: number;
};
export {};
