"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.existKeyframe = exports.getKeyframe = exports.addKeyframe = exports.removeKeyframe = void 0;

var toKeyframe = function toKeyframe(name, content) {
  return "\n  @-webkit-keyframes ".concat(name, " {\n    ").concat(content, "\n  }\n  @keyframes ").concat(name, " {\n    ").concat(content, "\n  }\n");
};

var removeKeyframe = function removeKeyframe(name) {
  var keyframe = document.getElementById(name);
  !!keyframe && document.getElementsByTagName('head')[0].removeChild(keyframe);
};

exports.removeKeyframe = removeKeyframe;

var addKeyframe = function addKeyframe(name, content) {
  var style = document.createElement('style');
  style.id = name;
  style.type = 'text/css';
  style.innerHTML = toKeyframe(name, content);
  document.getElementsByTagName('head')[0].appendChild(style);
};

exports.addKeyframe = addKeyframe;

var getKeyframe = function getKeyframe(name) {
  var keyframe = document.getElementById(name);
  return keyframe && keyframe.innerHTML;
};

exports.getKeyframe = getKeyframe;

var existKeyframe = function existKeyframe(name) {
  var keyframe = document.getElementById(name);
  return !!keyframe;
};

exports.existKeyframe = existKeyframe;